// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    EgfaDatenuebernahmeDTO,
    EgfaEntityRequestDTO,
    EgfaEntityRequestRenameDTO,
    EgfaEntityResponseDTO,
    EgfaModuleType,
    EgfaTableDTOs,
    EgfaTableFilterDTO,
    EgfaWithModulesTableResponseDTO,
    PaginierungDTO,
    RegelungsvorhabenEntityListResponseShortDTO,
} from '../models';

export interface ArchiveEgfaRequest {
    id: string;
}

export interface CreateEgfaRequest {
    egfaEntityRequestDTO: EgfaEntityRequestDTO;
}

export interface GetEgfaRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetEgfa1Request {
    id: string;
}

export interface GetEgfaArchivRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetEgfaFilterRequest {
    archiviert: boolean;
}

export interface GetEgfaWithModulesRequest {
    id: string;
}

export interface RenameEgfaRequest {
    id: string;
    egfaEntityRequestRenameDTO: EgfaEntityRequestRenameDTO;
}

export interface SendEgfaDatenuebernahmeRequest {
    id: string;
    moduleType: EgfaModuleType;
    egfaDatenuebernahmeDTO: EgfaDatenuebernahmeDTO;
}

/**
 * no description
 */
export class EgfaControllerApi extends BaseAPI {

    /**
     * Archiviert einen eGFA Container
     * eGFA archivieren
     */
    archiveEgfa({ id }: ArchiveEgfaRequest): Observable<void>
    archiveEgfa({ id }: ArchiveEgfaRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    archiveEgfa({ id }: ArchiveEgfaRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'archiveEgfa');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/egfa/{id}/archivieren'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Legt ein neues eGFA an
     * POST EGFA
     */
    createEgfa({ egfaEntityRequestDTO }: CreateEgfaRequest): Observable<EgfaEntityResponseDTO>
    createEgfa({ egfaEntityRequestDTO }: CreateEgfaRequest, opts?: OperationOpts): Observable<AjaxResponse<EgfaEntityResponseDTO>>
    createEgfa({ egfaEntityRequestDTO }: CreateEgfaRequest, opts?: OperationOpts): Observable<EgfaEntityResponseDTO | AjaxResponse<EgfaEntityResponseDTO>> {
        throwIfNullOrUndefined(egfaEntityRequestDTO, 'egfaEntityRequestDTO', 'createEgfa');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaEntityResponseDTO>({
            url: '/egfa',
            method: 'POST',
            headers,
            body: egfaEntityRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Liefert eine Liste für die eGFA-Tabelle.
     * Lädt alle eGFA
     */
    getEgfa({ paginierungDTO }: GetEgfaRequest): Observable<EgfaTableDTOs>
    getEgfa({ paginierungDTO }: GetEgfaRequest, opts?: OperationOpts): Observable<AjaxResponse<EgfaTableDTOs>>
    getEgfa({ paginierungDTO }: GetEgfaRequest, opts?: OperationOpts): Observable<EgfaTableDTOs | AjaxResponse<EgfaTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getEgfa');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaTableDTOs>({
            url: '/egfa/egfa',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt ein eGFA
     * GET EGFA
     */
    getEgfa1({ id }: GetEgfa1Request): Observable<EgfaEntityResponseDTO>
    getEgfa1({ id }: GetEgfa1Request, opts?: OperationOpts): Observable<AjaxResponse<EgfaEntityResponseDTO>>
    getEgfa1({ id }: GetEgfa1Request, opts?: OperationOpts): Observable<EgfaEntityResponseDTO | AjaxResponse<EgfaEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getEgfa1');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaEntityResponseDTO>({
            url: '/egfa/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert eine Liste der archivierten eGFA Container
     * Lädt alle archivierten eGFAs
     */
    getEgfaArchiv({ paginierungDTO }: GetEgfaArchivRequest): Observable<EgfaTableDTOs>
    getEgfaArchiv({ paginierungDTO }: GetEgfaArchivRequest, opts?: OperationOpts): Observable<AjaxResponse<EgfaTableDTOs>>
    getEgfaArchiv({ paginierungDTO }: GetEgfaArchivRequest, opts?: OperationOpts): Observable<EgfaTableDTOs | AjaxResponse<EgfaTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getEgfaArchiv');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaTableDTOs>({
            url: '/egfa/archiv',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Liste aller dynamischen Filter, die einem User zugeordnet sind
     * Lädt die dynamischen Filter für die Tabelle
     */
    getEgfaFilter({ archiviert }: GetEgfaFilterRequest): Observable<EgfaTableFilterDTO>
    getEgfaFilter({ archiviert }: GetEgfaFilterRequest, opts?: OperationOpts): Observable<AjaxResponse<EgfaTableFilterDTO>>
    getEgfaFilter({ archiviert }: GetEgfaFilterRequest, opts?: OperationOpts): Observable<EgfaTableFilterDTO | AjaxResponse<EgfaTableFilterDTO>> {
        throwIfNullOrUndefined(archiviert, 'archiviert', 'getEgfaFilter');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaTableFilterDTO>({
            url: '/egfa/filter/{archiviert}'.replace('{archiviert}', encodeURI(archiviert)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Liste der eGFA-Module
     * GET EGFA MODULES
     */
    getEgfaWithModules({ id }: GetEgfaWithModulesRequest): Observable<EgfaWithModulesTableResponseDTO>
    getEgfaWithModules({ id }: GetEgfaWithModulesRequest, opts?: OperationOpts): Observable<AjaxResponse<EgfaWithModulesTableResponseDTO>>
    getEgfaWithModules({ id }: GetEgfaWithModulesRequest, opts?: OperationOpts): Observable<EgfaWithModulesTableResponseDTO | AjaxResponse<EgfaWithModulesTableResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getEgfaWithModules');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaWithModulesTableResponseDTO>({
            url: '/egfa/{id}/modules'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben ab. Hinweis: Liefert nur Regelungsvorhaben im Status IN_BEARBEITUNG und der aktuelle Benutzer muss FEDERFÜHRER dieser Regelungsvorhaben sein. Wird benutzt um die Dropbox der Regelungsvorhabenzu befüllen, wenn man eine neue eGFA anlegt.
     * Lädt die Liste der Regelungsvorhaben zum Erstellen einer eGFA
     */
    getRegelungsvorhabenList(): Observable<RegelungsvorhabenEntityListResponseShortDTO>
    getRegelungsvorhabenList(opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityListResponseShortDTO>>
    getRegelungsvorhabenList(opts?: OperationOpts): Observable<RegelungsvorhabenEntityListResponseShortDTO | AjaxResponse<RegelungsvorhabenEntityListResponseShortDTO>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenEntityListResponseShortDTO>({
            url: '/egfa/regelungsvorhaben/list',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Benennt eine eGFA um
     * Rename eGFA
     */
    renameEgfa({ id, egfaEntityRequestRenameDTO }: RenameEgfaRequest): Observable<void>
    renameEgfa({ id, egfaEntityRequestRenameDTO }: RenameEgfaRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    renameEgfa({ id, egfaEntityRequestRenameDTO }: RenameEgfaRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'renameEgfa');
        throwIfNullOrUndefined(egfaEntityRequestRenameDTO, 'egfaEntityRequestRenameDTO', 'renameEgfa');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/egfa/{id}/rename'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: egfaEntityRequestRenameDTO,
        }, opts?.responseOpts);
    };

    /**
     * Sendet ein Modul zur eGFA Datenübernahme an den Editor
     * POST EGFA DATENUEBERNAHME
     */
    sendEgfaDatenuebernahme({ id, moduleType, egfaDatenuebernahmeDTO }: SendEgfaDatenuebernahmeRequest): Observable<void>
    sendEgfaDatenuebernahme({ id, moduleType, egfaDatenuebernahmeDTO }: SendEgfaDatenuebernahmeRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    sendEgfaDatenuebernahme({ id, moduleType, egfaDatenuebernahmeDTO }: SendEgfaDatenuebernahmeRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'sendEgfaDatenuebernahme');
        throwIfNullOrUndefined(moduleType, 'moduleType', 'sendEgfaDatenuebernahme');
        throwIfNullOrUndefined(egfaDatenuebernahmeDTO, 'egfaDatenuebernahmeDTO', 'sendEgfaDatenuebernahme');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/egfa/{id}/datenuebernahme/{moduleType}'.replace('{id}', encodeURI(id)).replace('{moduleType}', encodeURI(moduleType)),
            method: 'POST',
            headers,
            body: egfaDatenuebernahmeDTO,
        }, opts?.responseOpts);
    };

}
